现在的位置: 首页 > 综合 > 正文

hdu 3664 Permutation Counting(水DP)

2019年04月13日 ⁄ 综合 ⁄ 共 1783字 ⁄ 字号 评论关闭

Permutation Counting

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1171    Accepted Submission(s): 587

Problem Description
Given a permutation a1, a2, … aN of {1, 2, …, N}, we define its E-value as the amount of elements where ai > i. For example, the E-value of permutation {1, 3, 2, 4} is 1, while the E-value of {4, 3, 2, 1} is 2. You are requested to
find how many permutations of {1, 2, …, N} whose E-value is exactly k.
 

Input
There are several test cases, and one line for each case, which contains two integers, N and k. (1 <= N <= 1000, 0 <= k <= N).
 

Output
Output one line for each case. For the answer may be quite huge, you need to output the answer module 1,000,000,007.
 

Sample Input
3 0 3 1
 

Sample Output
1 4
Hint
There is only one permutation with E-value 0: {1,2,3}, and there are four permutations with E-value 1: {1,3,2}, {2,1,3}, {3,1,2}, {3,2,1}
 

Source
 

Recommend
lcy   |   We have carefully selected several similar problems for you:  3661 3665 3668 3669 3667 
 题意:
给你一个n和k。问你有多少种数字序列满足有k个数字比该数字对应的下标大。1到n中每个数字出现且出现一次。
比如数字序列3,4,1,2。其中3,4,比对应下标大。
思路:
有点类似错排公式。dp[i][j]表示用到1-i的数字。且有j个数字比下标大的方法数。那么
dp[i][j]=(j+1)*dp[i-1][j]+(i-j)*dp[i-1][j-1]。
公式很简单。当i放在dp[i-1][j]的j个位置或就放在第i个位置时。比下标大的数(E数)不会增加。dp[i][j]=(j+1)*dp[i-1][j]。
而当第i个数放到dp[i-1][j-1]的(i-1)-(j-1)个位置上时。E数会在dp[i-1][j-1]的基础上增加一个。dp[i][j]=(i-j)*dp[i-1][j-1]。
开始看到答案最多为1000000006所以用int存。结果wa了一发。因为在和(j+1)乘时就溢出了。所以要用__int64存。
详细见代码:

#include<algorithm>
#include<iostream>
#include<string.h>
#include<sstream>
#include<stdio.h>
#include<math.h>
#include<vector>
#include<string>
#include<queue>
#include<set>
#include<map>
using namespace std;
const int INF=0x3f3f3f3f;
const int maxn=100010;
const int mod=1000000007;
__int64 dp[1010][1010];
int main()
{
    int i,j,n,k;

    for(i=1;i<=1000;i++)
    {
        dp[i][0]=1;
        dp[i][i]=0;
        for(j=1;j<i;j++)
            dp[i][j]=((j+1)*dp[i-1][j]+(i-j)*dp[i-1][j-1])%mod;
    }
    while(~scanf("%d%d",&n,&k))
        printf("%I64d\n",dp[n][k]);
    return 0;
}


抱歉!评论已关闭.